#!/bin/sh
NS_HOST=myHD
APKG_PATH=/usr/local/AppCentral/${NS_HOST}
APKG_FOLDER=/usr/local/
MYHD_BIN=${APKG_PATH}/bin
BASE_URL="http://www.father-mande.ovh/A/other/"
LIST="delivery_${UVER}.list"
DIR_DELIVERY=/share/Public/${NS_HOST}_delivery

download_test(){
### now download if need ${FILE}
	if [ ! -e ${DIR_DELIVERY}/${FILE} ] ; then
		echo "=== Start download ${FILE} "
		$WGET -nv -O ${FILE} ${BASE_URL}/${FILE}
		### test if checksum is correct
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "=== ${FILE} is good and downloaded"
		else
			rm -f ${DIR_DELIVERY}/${FILE}
			echo "+++ Checksum invalid try to Restart download ${FILE} "
			$WGET -nv -O ${FILE} ${BASE_URL}/${FILE}
			if [ $? -ne 0 ] ; then
				echo "Hum seems ${FILE} can't be downloaded "
				echo "+++ FAILED ... END of install ====="
				exit 1
			fi
		fi
	else
		### test checksum
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "=== ${FILE} is good and downloaded"
		else
			rm -f ${DIR_DELIVERY}/${FILE}
			echo "+++ Checksum invalid try to Restart download ${FILE} "
			$WGET -nv -O ${FILE} ${BASE_URL}/${FILE}
			if [ $? -ne 0 ] ; then
				echo "Hum seems ${FILE} can't be downloaded "
				echo "+++ FAILED ... END of install ====="
				exit 1
			fi
		fi
	fi
}

exit_err(){
	echo "+++ FAILED ... END of install ====="
	/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} DOWNLOAD_RUNNING FALSE
	exit 1
}

if [ ! -z "${1}" ] ; then
	if [ "${1}" = "1604" -o "${1}" = "1804" ] ; then
		UVER=${1}
		LIST="delivery_${UVER}.list"
	else
		echo "First parameters MUST be Ubuntu version not : ${1}"
		exit_err
	fi
else
	echo "First parameters MUST be Ubuntu version supported by ${NS_HOST}"
	exit_err
fi
DOWNLOADED=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} DOWNLOADED)
INSTALLED=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} INSTALLED)
WGET=$(/usr/bin/which wget)
if [ $? -ne 0 ] ; then
	echo "+++ Hum wget is not present in the NAS ???"
	exit_err
fi 

PWD=$(pwd)
### test if already installed
if [ -e ${APKG_FOLDER}/.${NS_HOST} ] ; then
	 ### continue test
	if [ -e ${APKG_FOLDER}/.${NS_HOST}/${UVER} -a -e ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts -a -e ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_home ] ; then
		### HUM seem all is present so bypass download and set installed
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} INSTALLED TRUE 
		cp -p ${APKG_PATH}/bin/uninstall_environment.sh ${APKG_FOLDER}/.${NS_HOST}/
		cp -p ${APKG_PATH}/bin/uninstall_qpkg.sh ${APKG_FOLDER}/.${NS_HOST}/
		/usr/sbin/applog --level 0 --package "$#NS_HOST}" --event  "$UVER Ubuntu env. was reused ... and set as installed ... OK "
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} DOWNLOAD_RUNNING FALSE
		rm -f /share/Public/.${NS_HOST}_chroot_full
		echo "=== SUCCESS ... END of install ====="
	fi
fi
if [ "$DOWNLOADED" = "FALSE" ] ; then
	if [ ! -e ${DIR_DELIVERY} ] ; then
		mkdir ${DIR_DELIVERY}
	fi
	echo "Start download phase"
	cd ${DIR_DELIVERY}
	if [ ! -e ${DIR_DELIVERY}/$LIST ] ; then
		echo "=== Start download of : $LIST (list of files to download)"
		$WGET -nv -O $LIST ${BASE_URL}/$LIST
		if [ $? -ne 0 ] ; then
			echo "+++ Hum download error file : $LIST ... check or download manually"
			exit_err
		fi
	fi
	echo "=== Download of $LIST is complete"
	### verify if prelaoded the complete delivery_${UVER}.tgz
	DL_FULL="FALSE"
	FILE="${NS_HOST}_delivery_${UVER}.tgz"
	if [ -e ${DIR_DELIVERY}/${FILE} ] ; then
		echo "Full environment file already exist : check if it's the correct one"
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "=== file $FILE exist and are at the good version"
			DL_FULL="TRUE"
		fi
	fi
	DL_SCRIPT="FALSE"
	FILE=${NS_HOST}_${UVER}_delivery_scripts.tgz
	if [ -e ${DIR_DELIVERY}/${FILE} ] ; then
		echo "Scripts file already exist : check if it's the correct one"
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "=== file $FILE exist and are at the good version"
			DL_SCRIPT="TRUE"
		fi
	else
		download_test
	fi
	if [ "$DL_FULL" = "TRUE" ] ; then
		echo "=== ${NS_HOST}_delivery_${UVER}.tgz is already downloaded and at good version"
	else
		if [ -z "$2" ] ; then
			### here download part and generate tgz ...
			DL_PART="FALSE"
			NO_MORE="FALSE"
			for SUFFIX in aa ab ac ad ae af ag ah ai aj ak
			do
				grep ${NS_HOST}_delivery_${UVER}_${SUFFIX} ${DIR_DELIVERY}/$LIST
				if [ $? -eq 0 ] ; then
					FILE=${NS_HOST}_delivery_${UVER}_${SUFFIX}
					download_test
				else
					NO_MORE="TRUE"
				fi
				if [ "$NO_MORE" = "TRUE" ] ; then
					break
				fi
			done
			DL_PART="TRUE"
		else
			### download full environment in one file 
			FILE="${NS_HOST}_delivery_${UVER}.tgz"
			download_test
			DL_FULL="TRUE"
		fi
		## if you are here all part or full download works as well
		echo "Now we create the TAR file from parts"
		if [ "$DL_PART" = "TRUE" ] ; then
			cat ${NS_HOST}_delivery_${UVER}_* > ${NS_HOST}_delivery_${UVER}.tgz
		fi
		echo "=== tar file created : ${NS_HOST}_delivery_${UVER}.tgz "
		### last verification
		echo "Verify if checksum is correct "
		FILE="${NS_HOST}_delivery_${UVER}.tgz"
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "=== ${FILE} is good and downloaded"
			/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} DOWNLOADED TRUE
		else
			echo "+++ Hum download is complete but md5 is false strange ???"
			exit_err
		fi
	fi
fi
echo "=== Downloaded .finished NOW extract Ubuntu ..."
if [ "$INSTALLED" = "FALSE" ] ; then
	if [ ! -e ${APKG_FOLDER}/.${NS_HOST} ] ; then
		mkdir ${APKG_FOLDER}/.${NS_HOST}
	fi 
	cd ${APKG_FOLDER}/.${NS_HOST}
	echo "=== extract scripts"
	tar xzf ${DIR_DELIVERY}/${NS_HOST}_${UVER}_delivery_scripts.tgz
	### at end home folder if not exist
	if [ ! -e ${NS_HOST}_${UVER}_home ] ; then
		echo "=== extract Home folder"
		tar xzf ${APKG_PATH}/UBUNTU_${UVER}_home_delivery.tgz
	fi
	echo "=== extract Ubuntu BE PATIENT long archive (> 1GB) ... WAIT WAIT please"
	echo "=== AFTER extract ${NS_HOST} is restarted so perhaps you don't see last message but directly ${NS_HOST} status"
	tar xzf ${DIR_DELIVERY}/${NS_HOST}_delivery_${UVER}.tgz
	echo "=== ALL Ubuntu environment is installed"
	/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} INSTALLED TRUE 
	
	cp -p ${APKG_PATH}/bin/uninstall_environment.sh .
	cp -p ${APKG_PATH}/bin/uninstall_qpkg.sh .
	cd $PWD
fi 
echo "=== Downloaded and installed ... nothing to do anymore ..."
# /usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} DOWNLOAD_RUNNING FALSE
rm -f /share/Public/.${NS_HOST}_chroot_full
echo "seems all run as well"
/usr/sbin/applog --level 0 --package "${NS_HOST}" --event "$UVER Ubuntu env. was downloaded / installed ... OK "
echo "=== SUCCESS ... END of install Restart ${NS_HOST} ====="
### start ${NS_HOST} now
/usr/builtin/bin/sudo -u root ${APKG_PATH}/CONTROL/start-stop.sh start
