#!/bin/sh
NS_HOST=myHD
QPKG_PATH=/usr/local/AppCentral/${NS_HOST}
APKG_FOLDER=/usr/local/
UVER=$(/usr/bin/confutil -get ${QPKG_PATH}/${NS_HOST}.conf ${NS_HOST} UVER)
CHROOT_PATH=${APKG_FOLDER}/.${NS_HOST}/${UVER}

list_valid_user(){
echo "==== start list of valid user"
while read LINE
do
	if [ $(echo "$LINE" | cut -f 3 -d ":") -ge 500 -a "$(echo "$LINE" | cut -f 1 -d ":")" != "nobody" -a "$(echo "$LINE" | cut -f 1 -d ":")" != "guest" ] ; then
		echo "==== user : $(echo "$LINE" | cut -f 1 -d ":") is valid "
	fi
done < /etc/passwd
echo "==== end of list"
}
### test if a user name is proposed
if [ -z "$1" ] ; then
	echo "Please provide a USER_NAME as argument"
	list_valid_user
	exit 1
fi
### test if user name exist in Q.T.S.
/bin/grep -q "^${1}:" /etc/passwd
if [ $? -ne 0 ] ; then
	echo "HUM! $1 is not a valid QTS user ??? "
	list_valid_user
	exit 1
fi
### test that it's not nobody nor guest
if [ "$1" = "nobody" -o "$1" = "guest" ] ; then
	echo "Hum ! guest or nobody are not authorized"
	list_valid_user
	exit 1
fi
### test if not ALREADY exist in chroot ??
/bin/grep "^${1}:" ${CHROOT_PATH}/etc/passwd
if [ $? -eq 0 ] ; then
	echo "NOTHING TO DO already define in $NS_HOST"
	exit 1
fi
### test if UID >= 500
USER_UID=$(/bin/grep "^${1}:" /etc/passwd | cut -f 3 -d ":")
if [ $USER_UID -lt 500 ] ; then
	echo "USER must have a user_id >= 500 (start of QTS UID generation)"
	exit 1
fi
USER_GID=$(/bin/grep "^${1}:" /etc/passwd | cut -f 4 -d ":")
### test if group already exist in CHROOT
EXIST=""
while read LINE
do
	if [ $(echo "$LINE" | cut -f 3 -d ":") -eq $USER_GID ] ; then
		EXIST="TRUE"
		break
	fi
done < ${CHROOT_PATH}/etc/group
if [ -z "$EXIST" ] ; then
	echo "Group USER_GID don't exist need to be created"
	### loop to get group_id_name
	while read LINE
	do
		if [ $(echo "$LINE" | cut -f 3 -d ":") -eq $USER_GID ] ; then
			GID_NAME=$(echo "$LINE" | cut -f 1 -d ":")
			break
		fi
	done < /etc/group
	# echo "DEBUG : here we create new group $GID_NAME / $USER_GID in $NS_HOST  TODO"
	/usr/bin/${NS_HOST}_root addgroup --gid $USER_GID $GID_NAME
	echo "created group $GID_NAME witg group ID : $USER_GID"
	grep "^${GID_NAME}" ${CHROOT_PATH}/etc/group
fi
### now create the new user
# echo "DEBUG : here we create new user $1 / $USER_UID in $NS_HOST  TODO"
/usr/bin/${NS_HOST}_root adduser --uid $USER_UID --gecos "$1" --gid $USER_GID --disabled-password $1
sleep 1
echo "user $1 moved to $NS_HOST "
grep "^${1}:" ${CHROOT_PATH}/etc/passwd
## Now add user to group video, audio and copy relevent .asounrc / .bashrc
/usr/bin/${NS_HOST}_root adduser "$1" audio
/usr/bin/${NS_HOST}_root adduser "$1" video
/usr/bin/${NS_HOST}_root adduser "$1" root
## /usr/bin/${NS_HOST}_user $1 /bin/cp /${NS_HOST}_scripts/files/.asoundrc /home/${1}/
/usr/bin/${NS_HOST}_user $1 /bin/cp /${NS_HOST}_scripts/files/.bashrc /home/${1}/
## Now add keys for direct ssh command without password
/usr/bin/${NS_HOST}_user $1 /bin/mkdir /home/${1}/.ssh
/usr/bin/${NS_HOST}_user $1 /bin/cp /${NS_HOST}_scripts/files/authorized_keys /home/${1}/.ssh
/usr/bin/${NS_HOST}_user $1 /bin/chmod 640 /home/${1}/.ssh/authorized_keys

echo "moving user $1 is finished ... don't hesitate to control the result ... "

