#!/bin/sh
NS_HOST=myHD
UVER="1604"
BASE_URL="http://www.father-mande.ovh/A/other/"
DIR_DELIVERY=/share/Public/${NS_HOST}_delivery

download_test(){
### now download if need ${FILE}
	if [ ! -e ${DIR_DELIVERY}/${FILE} ] ; then
		$WGET -O ${FILE} ${BASE_URL}/${FILE}
		### test if checksum is correct
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "${FILE} is good and downloaded"
		else
			rm -f ${DIR_DELIVERY}/${FILE}
			$WGET -O ${FILE} ${BASE_URL}/${FILE}
			if [ $? -ne 0 ] ; then
				echo "Hum seems ${FILE} can't be downloaded "
				exit 1
			fi
		fi
	else
		### test checksum
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "${FILE} is good and downloaded"
		else
			rm -f ${DIR_DELIVERY}/${FILE}
			$WGET -O ${FILE} ${BASE_URL}/${FILE}
			if [ $? -ne 0 ] ; then
				echo "Hum seems ${FILE} can't be downloaded "
				exit 1
			fi
		fi
	fi
}

if [ ! -z "${1}" ] ; then
	if [ "${1}" = "1604" -o "${1}" = "1804" ] ; then
		UVER=${1}
		LIST="delivery_${UVER}.list"
	else
		echo "First parameters MUST be Ubuntu version not : ${1}"
		exit 1
	fi
else
	echo "First parameters MUST be Ubuntu version supported by ${NS_HOST}"
	exit 1
fi
/usr/bin/which wget
if [ $? -ne 0 ] ; then
	echo "Hum wget is not present in the NAS ???"
	exit 1
fi 

WGET=$(/usr/bin/which wget)
PWD=$(pwd)

	if [ ! -e ${DIR_DELIVERY} ] ; then
		mkdir ${DIR_DELIVERY}
	fi
	cd ${DIR_DELIVERY}
	if [ ! -e ${DIR_DELIVERY}/$LIST ] ; then
		$WGET -O $LIST ${BASE_URL}/$LIST
		if [ $? -ne 0 ] ; then
			echo "Hm download error file : $LIST ... check or download manually"
			exit 1
		fi
	fi
	### verify if prelaoded the complete delivery_${UVER}.tgz
	DL_FULL="FALSE"
	FILE="${NS_HOST}_delivery_${UVER}.tgz"
	if [ -e ${DIR_DELIVERY}/${FILE} ] ; then
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "file $FILE exist and are at the good version"
			DL_FULL="TRUE"
		fi
	fi
	DL_SCRIPT="FALSE"
	FILE=${NS_HOST}_${UVER}_delivery_scripts.tgz
	if [ -e ${DIR_DELIVERY}/${FILE} ] ; then
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "file $FILE exist and are at the good version"
			DL_SCRIPT="TRUE"
		fi
	else
		download_test
	fi
	if [ "$DL_FULL" = "TRUE" ] ; then
		echo "${NS_HOST}_delivery_${UVER}.tgz is already downloed and at good version"
	else
		if [ -z "$2" ] ; then
			### here download part and generate tgz ...
			DL_PART="FALSE"
			NO_MORE="FALSE"
			for SUFFIX in aa ab ac ad ae af ag ah ai aj ak
			do
				grep ${NS_HOST}_delivery_${UVER}_${SUFFIX} ${DIR_DELIVERY}/$LIST
				if [ $? -eq 0 ] ; then
					FILE=${NS_HOST}_delivery_${UVER}_${SUFFIX}
					download_test
				else
					NO_MORE="TRUE"
				fi
				if [ "$NO_MORE" = "TRUE" ] ; then
					break
				fi
			done
			DL_PART="TRUE"
		else
			### download full environment in one file 
			FILE="${NS_HOST}_delivery_${UVER}.tgz"
			download_test
			DL_FULL="TRUE"
		fi
		## if you are here all part or full download works as well
		if [ "$DL_PART" = "TRUE" ] ; then
			cat ${NS_HOST}_delivery_${UVER}_* > ${NS_HOST}_delivery_${UVER}.tgz
		fi
		### last verification
		FILE="${NS_HOST}_delivery_${UVER}.tgz"
		if [ "$(/usr/bin/md5sum ${DIR_DELIVERY}/${FILE} | cut -f 1 -d " ")" = "$(cat ${DIR_DELIVERY}/$LIST | grep ${FILE} | cut -f 1 -d " ")" ] ; then
			echo "${FILE} is good and downloaded"
		else
			echo "Hum download is complete but md5 is false strange ???"
			exit 1
		fi
	fi
echo "Downloaded ... finished ..."
