#!/bin/sh
NS_HOST=myHD
APKG_PATH=/usr/local/AppCentral/${NS_HOST}
APKG_FOLDER=/usr/local/
UVER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} UVER)
CHROOT_PATH=${APKG_FOLDER}/.${NS_HOST}/${UVER}
MYHD_BIN=${APKG_PATH}/bin
DROPBEAR_PORT=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} DROPBEAR_PORT)
EXIST="FALSE"
PROG=$(/usr/bin/basename $0)

list_user(){
        echo "LIST of user in ${NS_HOST} :"
        echo "root (NOT QNAP admin user but real root ${NS_HOST} user)"
        while read LINE
        do
                if [ $(echo $LINE | cut -f 3 -d ":") -ge 500 ] ; then
                        if [ "$(echo $LINE | cut -f 1 -d ":")" != "nobody" ] ; then
                                if [ "$(echo $LINE | cut -f 1 -d ":")" = "astr" ] ; then
                                        echo "$(echo $LINE | cut -f 1 -d ":") (it's Asustor admin user in ${NS_HOST})"
                                else
                                        echo "$(echo $LINE | cut -f 1 -d ":")"
                                fi
                        fi
                fi
        done < "${CHROOT_PATH}/etc/passwd"
        echo "End of the list"
}


### test if ${NS_HOST} is running
if [ ! -e /tmp/${NS_HOST}.pid ] ; then
	echo "Hum! seems that ${NS_HOST} is not started"
	exit 1
fi

if [ -z "$1" ] ; then
	echo "Usage : $0 user_name (user_name must be define in chroot)"
	list_user
	exit 1
### else ... test if use in passwd file
else
	while read LINE
        do
		if [ "$(echo $LINE | cut -f 1 -d ":")" = "$1" ] ; then
			EXIST="TRUE"
			break
		fi
	done < "${CHROOT_PATH}/etc/passwd"
fi
# echo "DGB : $@"
if [ "$EXIST" = "TRUE" ] ; then
	UUSER="$1"
	shift
# 	echo "DGB1 : $@"
	if [ ! -z "$1" ] ; then
		if [ "${PROG}" = "${NS_HOST}_user_ssh" ] ; then
			ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -p ${DROPBEAR_PORT} ${UUSER}@localhost "$*" 2>/dev/null
		else
			${APKG_PATH}/xbin/nsenter --target $(cat /tmp/${NS_HOST}.pid) --mount --ipc --pid --root --wd /bin/su - $UUSER -c "$* "
		fi
	else
		if [ "${PROG}" = "${NS_HOST}_user_ssh" ] ; then
			ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -p ${DROPBEAR_PORT} ${UUSER}@localhost 2>/dev/null
		else
			${APKG_PATH}/xbin/nsenter --target $(cat /tmp/${NS_HOST}.pid) --mount --ipc --pid --root --wd /bin/su - $UUSER
		fi
	fi
else
	echo "Hum! this (${1}) user don't exist in ${NS_HOST}"
fi
