#!/bin/sh 
NS_HOST=myHD
APKG_PATH=/usr/local/AppCentral/${NS_HOST}
MYHD_BIN=${APKG_PATH}/bin
ASPORTAL_PATH=/usr/local/AppCentral/asportal
ASPORTAL_STAT=`apkg --info-installed asportal | grep 'Enabled:' | awk '{print $2}'`
rcP=/usr/local/etc/init.d/P90myHD

NAME=${NS_HOST}

. /lib/lsb/init-functions

start_daemon () {

    [ -e "$rcP" ] || ln -s $APKG_PATH/CONTROL/start-stop.sh $rcP 
	${MYHD_BIN}/nohup ${APKG_PATH}/${NS_HOST}.sh start 2>&1 > /tmp/start_${NS_HOST}.log &
	
}

stop_daemon () {

    [ -e "$rcP" ] && rm -rf $rcP 	
    ${APKG_PATH}/${NS_HOST}.sh stop
}


case "$1" in
    start)
        log_daemon_msg "Starting daemon" "$NAME"
        start_daemon
        log_end_msg 0
        ;;
    stop)
        log_daemon_msg "Stopping daemon" "$NAME"
        stop_daemon
        log_end_msg 0
        ;;
    restart)
        log_daemon_msg "Restarting daemon" "$NAME"
        stop_daemon
        start_daemon
        log_end_msg 0
        ;;
    debug)
        ;;
    *)
        echo "Usage: $0 {start|stop|restart}"
        exit 2
        ;;
esac

if [ "$1" != "debug" ] ; then
    exit 0
fi
